@import '../../styles/variables';
@import '../../styles/mixins';

.cui-card {
  display: flex;
  flex-direction: column;
  min-width: 0;
  background-color: $cui-card-bg-color;
  @include cui-break-word();

  // ----- border radius

  @mixin radius($size) {
    border-radius: cui-border-radius($size) ;

    > :first-child {
      border-top-left-radius: cui-border-radius($size);
      border-top-right-radius: cui-border-radius($size);
    }
    > :last-child {
      border-bottom-left-radius: cui-border-radius($size);
      border-bottom-right-radius: cui-border-radius($size);
    }
  }

  @include radius(l);

  // ----- sizes

  @mixin size($outer, $inner) {
    > {
      .cui-card-content {
        padding-left: $outer;
        padding-right: $outer;
        &:first-child { padding-top: $outer; }
        &:last-child { padding-bottom: $outer; }
      }
      .cui-card-header {
        padding-bottom: $inner;
        &:not(:first-child) { padding-top: $outer; }
      }
      .cui-card-body > nav {
        margin-left: -$outer;
        margin-right: -$outer;
      }
      .cui-card-footer {
        padding-top: $inner;
        &:not(:last-child) { padding-bottom: $outer; }
      }
    }

    .cui-card-pull { margin: -$outer !important; width: calc(100% + #{2 * $outer}) !important; }
    .cui-card-pull-h { margin-left: -$outer !important; margin-right: -$outer !important; width: calc(100% + #{2 * $outer}) !important; }
    .cui-card-pull-v { margin-top: -$outer !important; margin-bottom: -$outer !important; }
    .cui-card-pull-t { margin-top: -$outer !important; }
    .cui-card-pull-l { margin-left: -$outer !important; width: calc(100% + #{$outer}) !important; }
    .cui-card-pull-r { margin-right: -$outer !important; width: calc(100% + #{$outer}) !important; }
    .cui-card-pull-b { margin-bottom: -$outer !important; }

    // --- deprecated
    .cui-card-pull-out {
      display: block;
      margin-left: -$outer;
      margin-right: -$outer;
      width: calc(100% + #{2 * $outer});
      &:not(:first-child) { margin-top: $outer; }
      &:not(:last-child) { margin-bottom: $outer; }
    }
  }

  @include size($cui-card-padding-outer, $cui-card-padding-inner);

  // ----- stacked cards

  .cui-card {
    border: 1px solid $cui-n50;
    margin-bottom: $cui-p-margin-bottom;
    @include radius(m);
    @include size($cui-card-stacked-padding-outer, $cui-card-stacked-padding-inner);
  }
}

// ----- header

.cui-card-header {
  display: flex;
}

.cui-card-header-content {
  flex: 1 1 auto;
  > *:last-child { margin-bottom: 0; }
}

.cui-card-menu {
  $-margin-compensation: (cui-line-height(m) - cui-height(s)) * 0.5;
  display: block;
  flex: 0 0 auto;
  margin: $-margin-compensation $-margin-compensation $-margin-compensation .5rem;
}

// ----- body

.cui-card-body {
  display: block;
  position: relative;
  > *:last-child { margin-bottom: 0; }

  // ----- navigation

  > nav {
    ul {
      list-style: none;
      margin: 0;
      padding: 0;
    }

    li {
      display: flex;
      align-items: center;
      position: relative;

      > .cui-button {
        flex: 1 1 auto;
        justify-content: flex-start;
        padding-left: $cui-card-padding-outer;
        padding-right: $cui-card-padding-outer;
        border-radius: 0;

        &.cui-active {
          box-shadow: inset 3px 0 0 cui-color('primary', text);
        }
      }

      .nav-actions {
        position: absolute;
        right: $cui-card-padding-outer;
        display: flex;
      }

      &:not(:hover):not(:focus):not(:focus-within) .nav-actions {
        @include cui-visually-hidden;
      }
    }
  }
}

// ----- footer

.cui-card-footer {
  display: flex;
  flex-direction: row-reverse;
  flex-wrap: wrap;
  row-gap: .5rem;
  column-gap: .5rem;
  margin-top: auto;
  > *:last-child { margin-bottom: 0; }
}
